<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class>
      <h1>Employers</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">
          <i class="mdi mdi-home-outline"></i>
        </el-breadcrumb-item>
        <el-breadcrumb-item>Employers</el-breadcrumb-item>
      </el-breadcrumb>

      <div style="text-align: right; position: relative">
        <el-button
          type="success"
          style="position: absolute; top: -30px; right: 0"
          class=""
          @click="exportReport"
        >
          <i class="mdi mdi-plus"> </i>
          <span> Export</span>
        </el-button>
      </div>
    </div>
    <br>

    <el-card v-if="not_found">
      <not-found />

    </el-card>
    <!-- <el-card
      v-else
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    > -->
    <el-table
      v-loading="loading"
      ref="content"
      id="content"
      rowClassName="pointer-row"
      :data="list"
      @row-click="showDetail"
    >
      <el-table-column
        fixed
        prop="id"
        label="ID"
        width="100"
      ></el-table-column>
      <el-table-column
        fixed
        prop="date"
        label="Avatar"
        width="120"
      >
        <template slot-scope="scope">
          <img
            @click="showAvatar(scope.row.user ? scope.row.user.avatar_url : null, $event)"
            class="img-responsive"
            :src="(scope.row.user && scope.row.user.avatar_url) ? scope.row.user.avatar_url :
                             $store.state.avtHolder"
          >
        </template>
      </el-table-column>
      <el-table-column
        min-width="200"
        prop="email"
        label="Email"
      ></el-table-column>
      <el-table-column
        min-width="150"
        prop="createDate"
        label="Created at"
      >
        <template slot-scope="scope">
          <span>{{scope.row.createDate | moment('DD-MM-YYYY') }}</span>
        </template>
      </el-table-column>
      <el-table-column
        min-width="150"
        prop="updateDate"
        label="Updated at"
      >
        <template slot-scope="scope">
          <span>{{scope.row.updateDate | moment('DD-MM-YYYY') }}</span>
        </template>
      </el-table-column>
      <el-table-column
        prop="isActive"
        label="Status"
        min-width="150"
      >
        <template slot-scope="scope">
          <div
            v-if="scope.row.isActive"
            style=""
          >
            <el-tag
              v-if="scope.row.isActive == '1'"
              style="min-width: 120px; text-align:center;"
              type="success"
              size="small"
              class="font-weight-500"
            >
              Active
            </el-tag>
            <el-tag
              v-if="scope.row.isActive == '0'"
              style="min-width: 120px; text-align:center;"
              type="danger"
              size="small"
              class="font-weight-500"
            >
              Inactive
            </el-tag>

          </div>
        </template>
      </el-table-column>

    </el-table>
    <div
      class="flex justify-space-between"
      style="align-items:center;"
    >

      <!-- <el-pagination
          v-if="total > pageSize"
          class="right"
          background
          layout="prev, pager, next"
          style="margin-top: 20px"
          :current-page="currentPage"
          :page-size="pageSize"
          @current-change="onChangePage"
          :total="total"
        ></el-pagination> -->
    </div>
    <!-- </el-card> -->

  </div>
</template>

<script>

import { employer as employerApi } from "~/services/apis/index";
import helper from "~/services/helper";
import NotFound from '../ContentNotFound'
import jsPDF from 'jspdf'
import html2canvas from "html2canvas"
import 'jspdf-autotable';
export default {
  name: "Contacts",
  components: {
    'not-found': NotFound
  },
  data () {
    return {
      list: [],
      search: "",
      dialogvisible: false,
      imageUrl: null,
      pageWidth: 0,
      userdata: {},
      loading: false,
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      defaultFilter: {
        prop: "post_job_quantity",
        order: "ascending"
      },
      sortBy: "",
      dir: "",
      prop: "",
      order: "",
      verifyOptions: [
        {
          value: "all",
          label: "All"
        },
        {
          value: "1",
          label: "Verified"
        },
        {
          value: "0",
          label: "Unverified"
        }
      ],
      verifyValue: "all",
      datePicker: '',
      from_date: '',
      to_date: '',
      not_found: false,
      isDisabledVerify: false
    };
  },
  computed: {
    onSubmit () {
      return this.$store.state.searchSubmit;
    }
  },
  watch: {
    onSubmit () {
      this.onSearch();
    },
    "$route" () {
      this.initParams();
      this.getListData();
    }
  },
  methods: {
    exportReport () {
      const doc = new jsPDF();
      doc.autoTable({        html: 'table.el-table__body', didDrawPage: function (data) {
          // Header
          doc.setFontSize(20);
          doc.setTextColor(40);
          doc.setFontStyle('normal');

          doc.text("Report Employer", data.settings.margin.left + 15, 22);

          // Footer
          var str = "Page " + doc.internal.getNumberOfPages()
          // Total page number plugin only available in jspdf v1.0+

          doc.setFontSize(10);

          // jsPDF 1.4+ uses getWidth, <1.4 uses .width
          var pageSize = doc.internal.pageSize;
          var pageHeight = pageSize.height ? pageSize.height : pageSize.getHeight();
          doc.text(str, data.settings.margin.left, pageHeight - 10);
        },
        margin: { top: 30 }      });
      // doc
      doc.save('employer.pdf');
    },

    updateStatus (row, data) {
      if (data == 0) {
        this.$confirm('Are you sure you want to deactive this user?', 'Warning', {
          confirmButtonText: 'Yes',
          cancelButtonText: 'Cancel',
          type: 'warning',
          center: true
        }).then(() => {
          this.loading = true
          //eslint-disable-next-line
          console.log('row,data :', row, data);
          employerApi.updateStatus(row, { isActive: data }).then(res => {
            if (res.status == 200) {
              this.$notify({
                title: "success",
                message: "Update status user successfully!",
                type: "success"
              });
              this.getListData()
            }
          }).catch(error => {
            this.$notify({
              title: "Error",
              message: "Cannot update status user!",
              type: "error"
            });
            this.loading = false
          })
        }).catch(error => {

        })
      } else if (data == 1) {
        this.loading = true
        //eslint-disable-next-line
        console.log('row,data :', row, data);
        employerApi.updateStatus(row, { isActive: data }).then(res => {
          if (res.status == 200) {
            this.$notify({
              title: "success",
              message: "Update status user successfully!",
              type: "success"
            });
            this.getListData()
          }
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot update status user!",
            type: "error"
          });
          this.loading = false
        })
      }
    },
    openDialog (data) {
      this.userdata = data;
      this.dialogvisible = true;
    },
    __resizeHanlder: _.throttle(function (e) {
      //this.setPageWidth()
    }, 700),
    getListData () {
      this.loading = true;

      employerApi
        .getEmployers(
        )
        .then(res => {
          //eslint-disable-next-line
          console.log('res :', res);
          this.list = res.data;
          this.loading = false;
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot get data from server!",
            type: "error"
          });
          this.loading = false
          this.not_found = true
        })
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;
      var id = row.id;
      this.$router.push({ name: "employers_detail", params: { id } });
    },


    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page);
      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      this.updateRoute(sQuery);
    },
    updateRoute (query) {

      this.$router.replace({ query: { page: 0 } });
      this.$router.replace({ name: "employers", query: query });
    },
    changeVerifyFilter (value) {
      if (value == "all") {
        this.verifyValue = "all";
      } else {
        this.verifyValue = value;
      }
      this.currentPage = 1;

      let sQuery = {};

      sQuery.page = this.currentPage;
      sQuery.is_verified = this.verifyValue;

      this.updateRoute(sQuery);
    },
    onSearch () {
      this.search = this.$store.state.search;

      this.currentPage = 1;

      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      sQuery.q = this.search;

      this.updateRoute(sQuery);
      this.$store.commit("setSearchValue", this.search);
    },

    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    },
    changeDateFilter (value) {
      if (!value) {
        this.updateRoute()
        return
      }
      this.currentPage = 1;

      let sQuery = this.$route.query;

      if (this.datePicker && this.datePicker.length === 2) {

        this.from_date = this.datePicker[0]
        this.to_date = this.datePicker[1]
      }

      sQuery.page = this.currentPage;
      sQuery.from_date = this.from_date
      sQuery.to_date = this.to_date
      this.updateRoute(sQuery)
    }

  },
  mounted () {
    //eslint-disable-next-line
    console.log('this.$el :', this.$el);
    //eslint-disable-next-line
    console.log('this.$refs.content :', this.$refs.content);

    this.getListData();
  }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";

.btn-eye {
  padding: 1px 6px;
}

@media (max-width: 768px) {
}
</style>

